; Dragon Rising Auto Host v2.0
Sleep, 500
IfWinNotExist Dragon Rising
{
	MsgBox, Could not find game window
	ExitApp
}
WinActivate
WinGetPos iPosX, iPosY, iWidth, iHeight
If ((iWidth > 810) || (iHeight > 630) || (iWidth < 800) || (iHeight < 600))
{
	MsgBox, Error, game must be windowed with resoultion of 800x600
	ExitApp
}
iFileNumber := 1

loop 4
{
	iLine = 1
	sFileName = %A_ScriptDir%\DR Server\Settings%iFileNumber%.txt
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If((sLine = "Y") || (sLine = "N"))
			{
				sFileUsed%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid enable setting in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			StringLen, iCount, sLine
			if(iCount < 32)
			{
				sServerName%iFileNumber% := sLine
				break
			}
			else
			{
				MsgBox, Server Name must be less than 32 characters in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			StringLen, iCount, sLine
			if(iCount < 80)
			{
				sMOTD1%iFileNumber% := sLine
				break
			}
			else
			{
				MsgBox, Message of the Day 1 must be less than 80 characters in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			StringLen, iCount, sLine
			if(iCount < 80)
			{
				sMOTD2%iFileNumber% := sLine
				break
			}
			else
			{
				MsgBox, Message of the Day 2 must be less than 80 characters in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			StringLen, iCount, sLine
			if(iCount < 80)
			{
				sMOTD3%iFileNumber% := sLine
				break
			}
			else
			{
				MsgBox, Message of the Day 3 must be less than 80 characters in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine > 10)
			{
				iRefresh%iFileNumber% := Floor(sLine * 1000)
				break
			}
			Else
			{
				MsgBox, Invalid server refresh rate minimum of 10 seconds in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sDeepSleep%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid deep sleep mode
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sRanked%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid ranked match Input in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sRandomGame%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid random game input in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "B") || (sLine = "S") || (sLine = "A") || (sLine = "I"))
			{
				sGameType%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid Game Type in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sRandomMap%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid random map input in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine >= 1)
			{
				iBlindsideMin%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				MsgBox, Random blindside minimum must be greater than or equal to 1 in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine > iBlindsideMin%iFileNumber%)
			{
				iBlindsideMax%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				iCount := iBlindsideMin%iFileNumber%
				MsgBox, Random blindside maximum must be greater than random blindside minimum (%iCount%) in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
		loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine >= 1)
			{
				iSupremacyMin%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				MsgBox, Random supremacy minimum must be greater than or equal to 1 in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine > iSupremacyMin%iFileNumber%)
			{
				iSupremacyMax%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				iCount := iSupremacyMin%iFileNumber%
				MsgBox, Random supremacy maximum must be greater than random supremacy minimum (%iCount%) in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
		loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine >= 1)
			{
				iAnnihilationMin%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				MsgBox, Random annihilation minimum must be greater than or equal to 1 in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine > iAnnihilationMin%iFileNumber%)
			{
				iAnnihilationMax%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				iCount := iAnnihilationMin%iFileNumber%
				MsgBox, Random annihilation maximum must be greater than random annihilation minimum (%iCount%) in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine >= 1)
			{
				iInfiltrationMin%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				MsgBox, Random infiltration minimum must be greater than or equal to 1 in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If (sLine > iInfiltrationMin%iFileNumber%)
			{
				iInfiltrationMax%iFileNumber% := (Floor(sLine))
				break
			}
			Else
			{
				iCount := iInfiltrationMin%iFileNumber%
				MsgBox, Random infiltration maximum must be greater than random infiltration minimum (%iCount%) in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 2) && (sLine <= 32))
			{
				iMaxPlayers%iFileNumber% := (Floor(sLine)) - 1
				break
			}
			Else
			{
				MsgBox, Max players must be in range 2 to 32 in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "N") || (sLine = "E") || (sLine = "H"))
			{
				sDifficulty%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid difficulty in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 2) && (sLine <= (iMaxPlayers%iFileNumber% + 1)))
			{
				iMinPlayers%iFileNumber% := (Floor(sLine)) - 2
				break
			}
			Else
			{
				MsgBox, Invalid minimum players in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = 5) || (sLine = 10) || (sLine = 15) || (sLine = 20) || (sLine = 30) || (sLine = 60))
			{
				If (((sGameType%iFileNumber% = "B") || (sGameType%iFileNumber% = "I")) && (sLine < 15))
				{
					iGameTime%iFileNumber% := 15
				}
				Else
				{
					iGameTime%iFileNumber% := sLine
				}
				break
			}
			Else
			{
				MsgBox, Invalid game time in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = 20) || (sLine = 40) || (sLine = 60))
			{
				iSpawnTime%iFileNumber% := Floor((sLine/20) - 1)
				break
			}
			Else
			{
				MsgBox, Invalid respawn time in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "U") || (sLine = "N") || (sLine = "R"))
			{
				sRespawnType%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid respawn type in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sFriendlyFire%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid friendly fire setting in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sKickOnTK%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid kick on teamkill setting in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 3) && (sLine <= 25))
			{
				iTKtoKick%iFileNumber% := (Floor(sLine)) - 3
				break
			}
			Else
			{
				MsgBox, Invalid team kills to kick in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 10) && (sLine <= 2000))
			{
				iScore1 := Floor((sLine/10) - 1)
				If(iScore1 > 100)
				{
					iScore1 -= 100
				}
				Else
				{
					iScore1 := 0 - (100 - Score1)
				}
				break
			}
			Else
			{
				MsgBox, Invalid supremacy match point limit in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 1) && (sLine <= 500))
			{
				iScore2 := Floor(sLine)
				If(iScore2 > 49)
				{
					iScore2 -= 50
				}
				Else
				{
					iScore2 := 0 - (50 - iScore2)
				}
				break
			}
			Else
			{
				MsgBox, Invalid annihilation match point limit in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	If(sGameType%iFileNumber% = "S")
	{
		iMatchPointLimit%iFileNumber% := iScore1
	}
	Else
	{
		iMatchPointLimit%iFileNumber% := iScore2
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 1) && (sLine <= 10))
			{
				iMaps%iFileNumber% := Floor(sLine)
				break
			}
			Else
			{
				MsgBox, Invalid map count in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "Y") || (sLine = "N"))
			{
				sShuffle%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid map shuffle setting in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine >= 0) && (sLine <= 31))
			{
				iPrivateSlots%iFileNumber% := Floor(sLine)
				break
			}
			Else
			{
				MsgBox, Invalid private slots count in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	loop
	{
		GoSub ReadLine
		If (sOut != ";")
		{
			If ((sLine = "U") || (sLine = "C"))
			{
				sSide%iFileNumber% := sLine
				break
			}
			Else
			{
				MsgBox, Invalid Game Type in Settings%iFileNumber%.txt
				ExitApp
			}
		}
	}
	iMapIndex := 1
	loop 10
	{
		loop
		{
			GoSub ReadLine
			If (sOut != ";")
			{
				If (sLine > 0)
				{
					MapArray%iFileNumber%_%iMapIndex% := (Floor(sLine)) - 1
					iMapIndex++
					break
				}
				Else
				{
					MsgBox, Invalid index for map %iMapIndex% in Settings%iFileNumber%.txt
					ExitApp
				}
			}
		}
	}
	iFileNumber++
}
;MsgBox, %sFileUsed1% %sFileUsed2% %sFileUsed3% %sFileUsed4%
; Delete some variables that are no longer needed
iScore1 := ""
iScore2 := ""
sOut := ""
;MsgBox, %sGameType1% %sGameType2% %sGameType3% %sGameType4%
iFileNumber := 1
If(sFileUsed1 = "N")
{
	If(sFileUsed2 = "Y")
	{
		iFileNumber := 2
	}
	Else
	{
		If(sFileUsed3 = "Y")
		{
			iFileNumber := 3
		}
		Else
		{
			If(sFileUsed4 = "Y")
			{
				iFileNumber := 4
			}
			Else
			{
				MsgBox, Error! All Settings files are disabled
				ExitApp
			}
		}	
	}
}
WinActivate
WinMove, 0, 0
Sleep, 1000
Click 130, 270
Sleep, 1000
Click 130, 270
Sleep, 1000
Click 130, 270
Sleep, 1000
If (sRanked%iFileNumber% = "Y")
{
	Send {Right Down}
	Sleep, 200
	Send {Right Up}
	Sleep, 200
}
loop
{
	If(sRandomGame%iFileNumber% = "Y")
	{
		Random, Rand, 1, 5
		If(Rand > 4)
		{
			sGameType%iFileNumber% = I
		}
		Else
		{
			If(Rand > 3)
			{
				sGameType%iFileNumber% = A
			}
			Else
			{
				If(Rand > 2)
				{
					sGameType%iFileNumber% = S
				}
				Else
				{
					sGameType%iFileNumber% = B
				}
			}
		}
	}
	If(sShuffle%iFileNumber% = "Y")
	{
		iMapIndex := 10
		loop 10
		{
			Random, Rand, 1, 10
			Rand := Round(Rand, 0)
			iSwap := MapArray%iFileNumber%_%Rand%
			MapArray%iFileNumber%_%Rand% := MapArray%iFileNumber%_%iMapIndex%
			MapArray%iFileNumber%_%iMapIndex% := iSwap
			iMapIndex--
		}
	}
	If(sRandomMap%iFileNumber% = "Y")
	{
		iMapIndex := 1
		iCount := iMaps%iFileNumber%
		If(sGameType%iFileNumber% = "B")
		{
			iMin := iBlindsideMin%iFileNumber%
			iMax := iBlindsideMax%iFileNumber%
		}
		Else
		{
			If(sGameType%iFileNumber% = "S")
			{
				iMin := iSupremacyMin%iFileNumber%
				iMax := iSupremacyMax%iFileNumber%
			}
			Else
			{
				If(sGameType%iFileNumber% = "A")
				{
					iMin := iAnnihilationMin%iFileNumber%
					iMax := iAnnihilationMax%iFileNumber%
				}
				Else
				{
					iMin := iInfiltrationMin%iFileNumber%
					iMax := iInfiltrationMax%iFileNumber%
				}
			}
		}
		loop %iCount%
		{
			Random, Rand, iMin, iMax
			MapArray%iFileNumber%_%iMapIndex% := (Round(Rand,0)) - 1
			iMapIndex++
		}
	}
	IfWinNotExist
	{
		MsgBox, Could not find game window
		ExitApp
	}
	iLatency := (iMaps%iFileNumber% * iGameTime%iFileNumber% * 60000) + (iMaps%iFileNumber% * 120000) + 60000
	WinActivate
	; Online Menu
	Click 130, 340, 0
	Sleep, 100
	Send {Enter Down}
	Sleep, 100
	; Click Create Server
	Send {Enter Up}
	Sleep 4000
	; MsgBox Create Server

	If (sGameType%iFileNumber% = "B")
	{
		iCount = 1
	}
	Else
	{
		If (sGameType%iFileNumber% = "S")
		{
			iCount = 2
		}
		Else
		{
			If (sGameType%iFileNumber% = "A")
			{
				iCount = 3
			}
			Else
			{
				iCount = 4
			}
		}
	}
	Click 380, 325, 0
	Sleep, 100
	loop %iCount%
	{	
		Send {Right Down}
		Sleep, 100
		Send {Right Up}
		Sleep, 100
	}
	Click 380, 351, 0
	Sleep, 100
	if(iMaxPlayers != 31)
	{
		iCount := iMaxPlayers%iFileNumber%
		loop %iCount%
		{
			Send {Right Down}
			Sleep, 100
			Send {Right Up}
			Sleep, 100
		}
	}
	Click 380, 425, 0
	Sleep, 100
	If (sDifficulty%iFileNumber% = "E")
	{
		Send {Right Down}
		Sleep, 100
		Send {Right Up}
		Sleep, 100
	}
	Else
	{
		If (sDifficulty%iFileNumber% = "H")
		{
	
			loop 2
			{
				Send {Right Down}
				Sleep, 100
				Send {Right Up}
				Sleep, 100
			}
		}
	}
	Click 200, 585, 0
	Sleep, 100
	; Click Advanced
	Send {F1 Down}
	Sleep, 100
	Send {F1 Up}
	Sleep, 4000
	Click 440, 260, 0
	Sleep, 100
	loop 31
	{
		Send {Backspace Down}
		Sleep, 100
		Send {Backspace Up}
		Sleep, 50
	}
	StringLen, iCount, sServerName%iFileNumber%
	sLine := sServerName%iFileNumber%
	SendRaw %sLine%
	Send {Down Down}
	Sleep, 100
	Send {Down Up}
	Sleep, 100
	iCount := iMinPlayers%iFileNumber%
	loop %iCount%
	{
		Send {Right Down}
		Sleep, 100
		Send {Right Up}
		Sleep, 100
	}
	Send {Down Down}
	Sleep, 100
	Send {Down Up}
	Sleep, 100
	If (iGameTime%iFileNumber% = 5)
	{
		loop 3
		{
			Send {Left Down}
			Sleep, 100
			Send {Left Up}
			Sleep, 100
		}
	}
	Else
	{
		If (iGameTime%iFileNumber% = 10)
		{
			loop 2
			{
				Send {Left Down}
				Sleep, 100
				Send {Left Up}
				Sleep, 100
			}
		}
		Else
		{
			If (iGameTime%iFileNumber% = 15)
			{
				Send {Left Down}
				Sleep, 100
				Send {Left Up}
				Sleep, 100
			}
			Else
			{
				If (iGameTime%iFileNumber% = 30)
				{
					Send {Right Down}
					Sleep, 100
					Send {Right Up}
					Sleep, 100
				}
				Else
				{
						If (iGameTime%iFileNumber% = 60)
						{
							Send {Right Down}
							Sleep, 100
							Send {Right Up}
							Sleep, 100
						}
				}
			}
		}
	}
	Send {Down Down}
	Sleep, 100
	Send {Down Up}
	Sleep, 100
	iCount := iSpawnTime%iFileNumber%
	loop %iCount%
	{
		Send {Right Down}
		Sleep, 100
		Send {Right Up}
		Sleep, 100
	}
	If(sGameType%iFileNumber% != "S")
	{	
		Send {Down Down}
		Sleep, 100
		Send {Down Up}
		Sleep, 100
		If(sRespawnType%iFileNumber% = "N")
		{
			Send {Right Down}
			Sleep, 100
			Send {Right Up}
			Sleep, 100
		}
		Else
		{
			If (sRespawnType%iFileNumber% = "R")
			{
				loop 2
				{
					Send {Right Down}
					Sleep, 100
					Send {Right Up}
					Sleep, 100
				}
			}
		}
	}
	Send {Down Down}
	Sleep, 100
	Send {Down Up}
	Sleep, 100
	If (sFriendlyFire%iFileNumber% = "Y")
	{
		Send {Down Down}
		Sleep, 100
		Send {Down Up}
		Sleep, 100
		If (sKickOnTK%iFileNumber% = "Y")
		{
			Send {Right Down}
			Sleep, 100
			Send {Right Up}
			Sleep, 100
			Send {Down Down}
			Sleep, 100
			Send {Down Up}
			Sleep, 100
			iCount := iTKtoKick%iFileNumber%
			loop %iCount%
			{
				Send {Right Down}
				Sleep, 100
				Send {Right Up}
				Sleep, 100
			}	
		}
	}
	Else
	{
		Send {Right Down}
		Sleep, 100
		Send {Right Up}
		Sleep, 100
	}
	If ((sGameType%iFileNumber% == "S") || (sGameType%iFileNumber% == "A"))
	{
		Send {Down Down}
		Sleep, 100
		Send {Down Up}
		Sleep, 100
		If (iMatchPointLimit%iFileNumber% < 0)
		{
			iCount := Abs(iMatchPointLimit%iFileNumber%)
			If(sGameType%iFileNumber% == "S")
			{
				iCount-- 
			}
			loop %iCount%
			{
				Send {Left Down}
				Sleep, 100
				Send {Left Up}
				Sleep, 50
			}
		}
		Else
		{
			iCount := iMatchPointLimit%iFileNumber%
			If(sGameType%iFileNumber% == "S")
			{
				iCount++
			}
			loop %iCount%
			{
				Send {Right Down}
				Sleep, 100
				Send {Right Up}
				Sleep, 50
			}
		}
	}
	If (sRanked%iFileNumber% = "N")
	{
		Send {Down Down}
		Sleep, 100
		Send {Down Up}
		Sleep, 100
		iCount := iPrivateSlots%iFileNumber%
		loop %iCount%
		{
			Send {Right Down}
			Sleep, 100
			Send {Right Up}
			Sleep, 100
		}
	}
	Sleep, 100
	; Accept
	Click 127, 588, 0
	Send {Enter Down}
	Sleep, 100
	Send {Enter Up}
	Sleep, 4000
	;  Map list
	Click 310, 585, 0
	Send {F2 Down}
	Sleep, 100
	Send {F2 Up}
	Sleep, 4000
	Click 105, 233
	; Selected server maps
	Send {Enter Down}
	Sleep, 500
	Send {Enter Up}
	Sleep, 100
	; Removed default map
	Click 415, 233
	; Selected available maps
	iMapIndex := 1
	iDifference := 0
	iCurrentPosition := 0
	iNewMapNumber := 0
	iCount := iMaps%iFileNumber%
	loop %iCount%
	{
		iNewMapNumber := MapArray%iFileNumber%_%iMapIndex%
		iDifference := iNewMapNumber - iCurrentPosition
		;MsgBox, Current %iCurrentPosition% Target %iNewMapNumber% Difference %iDifference%
		If(iDifference < 0)
		{
			; Move up to map
			iDifference := Abs(iDifference)
			loop %iDifference%
			{
				Send {Up Down}
				Sleep, 100
				Send {Up Up}
				Sleep, 100
				iCurrentPosition--
			}	
		}
		Else
		{
			; Move down to map
			loop %iDifference%
			{
				Send {Down Down}
				Sleep, 100
				Send {Down Up}
				Sleep, 100
				iCurrentPosition++
			}
		}
		; Add map
		Send {Enter Down}
		Sleep, 100
		Send {Enter Up}
		Sleep, 100
		iMapIndex++
	}
	; Back
	Send {Escape Down}
	Sleep, 100
	Send {Escape Up}
	Sleep, 4000
	; Create the server
	Click 230, 490, 0
	Send {Enter Down}
	Sleep, 100
; Ack any bandwidth warning
	Send {Enter Up}
	Sleep, 3000
	Click 400, 80
	Send {Enter Down}
	Sleep, 100
	Send {Enter Up}
	Sleep, 3000
	; Multiplayer Lobby
	If (sSide%iFileNumber% = "C")
	{
		Send {F1 Down}
		Sleep, 500
		Send {F1 Up}
		Sleep, 500
	}
	Click 450, 500
	Sleep, 1000
	Click 450, 500
	iCount := 0
	; Lobby loop
	loop
	{
		; Wait for minimum players
		iTime := iRefresh%iFileNumber%
		Sleep, %iTime%
		IfWinNotExist
		{
			MsgBox, Could not find game window
			ExitApp
		}
		WinRestore
		WinActivate
		Sleep, 500
		Click 400, 100
		Send {F8 Down}
		Sleep, 500
		Send {F8 Up}	
		ImageSearch, iFoundX, iFoundY, 50, 500, 400, 600, %A_ScriptDir%\DR Server\black.bmp
		If (ErrorLevel = 2)
		{
			MsgBox, Could not load %A_ScriptDir%\DR Server\black.bmp
		}
		Else
		{
			If (ErrorLevel = 1)
			{
				break
			}
		}
		iCount += iRefresh%iFileNumber%
		if(iCount > 300000)
		{
			Click 450, 500
			Sleep, 1000
			Click 450, 500
			Sleep, 500
			sLine := sMOTD1%iFileNumber%
			SendRaw %sLine%
			Sleep, 500
			Send {Enter Down}
			Sleep, 500
			Send {Enter Up}
			Sleep, 500
			sLine := sMOTD2%iFileNumber%
			SendRaw %sLine%
			Sleep, 500
			Send {Enter Down}
			Sleep, 500
			Send {Enter Up}
			Sleep, 500
			sLine := sMOTD3%iFileNumber%
			SendRaw %sLine%
			Sleep, 500
			Send {Enter Down}
			Sleep, 500
			Send {Enter Up}
			Sleep, 500
			iCount := 0
		}
	}
	If(sDeepSleep%iFileNumber% = "Y")
	{
		Sleep, %iLatency%
	}
	Else
	{
		iCount := 0
		loop
		{
			iTime := iRefresh%iFileNumber%
			Sleep, %iTime%
			iCount += iRefresh%iFileNumber%
			IfWinNotExist
			{
				MsgBox, Could not find game window
				ExitApp
			}
			WinRestore
			WinActivate
			Sleep, 500
			Click 450, 100
			If(iCount > iLatency)
			{
				break
			}
			ImageSearch, iFoundX, iFoundY, 0, 590, 50, 620, %A_ScriptDir%\DR Server\V1.bmp
			If(ErrorLevel = 2)
			{
				MsgBox, Could not load %A_ScriptDir%\DR Server\V1.bmp
			}
			Else
			{
				If(ErrorLevel = 0)
				{
					break
				}
			}
		}
	}
	WinRestore
	WinActivate
	; Click on Ranked server line (enter has no effect if used on this line)
	Sleep, 1000
	Click 290, 273
	Sleep, 1000
	Click 290, 273
	Sleep, 1000
	Click 290, 273
	Sleep, 1000
	; Ack connection error (doesn't matter if there wasn't one because the cursor was on the ranked server line)
	Send {Enter Down}
	Sleep, 500
	Send {Enter Up}
	Sleep, 2000
	sLine := sRanked%iFileNumber%
	loop
	{
		iFileNumber++
		If(iFileNumber = 5)
		{
			iFileNumber := 1
		}
		If(sFileUsed%iFileNumber% = "Y")
		{
			break
		}
	}
	If (sRanked%iFileNumber% != sLine)
	{
		Send {Right Down}
		Sleep, 200
		Send {Right Up}
		Sleep, 200
	}
}
return

ReadLine:
FileReadLine, sLine, %sFileName%, %iLine%
If ErrorLevel
{
	MsgBox, Could not read line %iLine% of file %A_ScriptDir%\DR Server\Settings.txt
	ExitApp
}
StringLeft, sOut, sLine, 1
iLine++
return